require 'modshogun'

f_feats_train = Modshogun::CSVFile.new "../../data/classifier_4class_2d_linear_features_train.dat"

#![create_features]
features_train = Modshogun::RealFeatures.new f_feats_train
#![create_features]

#![choose_distance]
distance = Modshogun::EuclideanDistance.new features_train, features_train
#![choose_distance]

#![create_instance]
merges = 3
hierarchical = Modshogun::Hierarchical.new merges, distance
#![create_instance]

#![train_model]
hierarchical.train 
#![train_model]

#![extract_results]
d = hierarchical.get_merge_distances 
cp = hierarchical.get_cluster_pairs 
#![extract_results]

# Serialize output for integration testing (automatically generated)
__sg_storage = Modshogun::WrappedObjectArray.new 
__sg_storage_file = Modshogun::SerializableAsciiFile.new "hierarchical.dat", 'w'
__sg_storage.append_wrapped_int merges, "merges"
__sg_storage.append_wrapped_real_vector d, "d"
__sg_storage.save_serializable __sg_storage_file
