require 'modshogun'

f_feats_train = Modshogun::CSVFile.new "../../data/classifier_4class_2d_linear_features_train.dat"
f_feats_test = Modshogun::CSVFile.new "../../data/classifier_4class_2d_linear_features_test.dat"
f_labels_train = Modshogun::CSVFile.new "../../data/classifier_4class_2d_linear_labels_train.dat"
f_labels_test = Modshogun::CSVFile.new "../../data/classifier_4class_2d_linear_labels_test.dat"

#![create_features]
features_train = Modshogun::RealFeatures.new f_feats_train
features_test = Modshogun::RealFeatures.new f_feats_test
labels_train = Modshogun::MulticlassLabels.new f_labels_train
labels_test = Modshogun::MulticlassLabels.new f_labels_test
#![create_features]

#![create_instance]
qda = Modshogun::QDA.new features_train, labels_train, 0.0001, true
#![create_instance]

#![train_and_apply]
qda.train 
labels_predict = qda.apply_multiclass features_test
#![train_and_apply]

#![extract_mean_and_cov]
classlabel = 1
m = qda.get_mean classlabel
c = qda.get_cov classlabel
#![extract_mean_and_cov]

#![evaluate_accuracy]
eval = Modshogun::MulticlassAccuracy.new 
accuracy = eval.evaluate labels_predict, labels_test
#![evaluate_accuracy]

# additional integration testing variables
output = labels_predict.get_labels 

# Serialize output for integration testing (automatically generated)
__sg_storage = Modshogun::WrappedObjectArray.new 
__sg_storage_file = Modshogun::SerializableAsciiFile.new "quadratic_discriminant_analysis.dat", 'w'
__sg_storage.append_wrapped_int classlabel, "classlabel"
__sg_storage.append_wrapped_real_vector m, "m"
__sg_storage.append_wrapped_real_matrix c, "c"
__sg_storage.append_wrapped_real accuracy, "accuracy"
__sg_storage.append_wrapped_real_vector output, "output"
__sg_storage.save_serializable __sg_storage_file
