require 'modshogun'

f_feats_train = Modshogun::CSVFile.new "../../data/regression_1d_linear_features_train.dat"
f_feats_test = Modshogun::CSVFile.new "../../data/regression_1d_linear_features_test.dat"
f_labels_train = Modshogun::CSVFile.new "../../data/regression_1d_linear_labels_train.dat"
f_labels_test = Modshogun::CSVFile.new "../../data/regression_1d_linear_labels_test.dat"
Modshogun::Math.init_random 1

#![create_features]
features_train = Modshogun::RealFeatures.new f_feats_train
features_test = Modshogun::RealFeatures.new f_feats_test
labels_train = Modshogun::RegressionLabels.new f_labels_train
labels_test = Modshogun::RegressionLabels.new f_labels_test
#![create_features]

#![create_combination_rule]
mean_rule = Modshogun::MeanRule.new 
#![create_combination_rule]

#![create_instance]
rand_forest = Modshogun::RandomForest.new features_train, labels_train, 5
rand_forest.set_combination_rule mean_rule
#![create_instance]

#![train_and_apply]
rand_forest.train 
labels_predict = rand_forest.apply_regression features_test
#![train_and_apply]

#![evaluate_error]
mse = Modshogun::MeanSquaredError.new 
oob = rand_forest.get_oob_error mse
mserror = mse.evaluate labels_predict, labels_test
#![evaluate_error]

# additional integration testing variables
output = labels_predict.get_labels 

# Serialize output for integration testing (automatically generated)
__sg_storage = Modshogun::WrappedObjectArray.new 
__sg_storage_file = Modshogun::SerializableAsciiFile.new "random_forest_regression.dat", 'w'
__sg_storage.append_wrapped_real oob, "oob"
__sg_storage.append_wrapped_real mserror, "mserror"
__sg_storage.append_wrapped_real_vector output, "output"
__sg_storage.save_serializable __sg_storage_file
